import React, {useState} from 'react'
import Input from "../../components/Input";
import Button from "../../components/Button";
import './style.css'

let step = 0

const FileUploader=()=> {
    const convertToBase64 = file => {
        return new Promise((res, rej) => {
            const fileReader = new FileReader()
            fileReader.onload = () => {
                res(fileReader.result)
            }
            fileReader.onerror = (err) => {
                rej(err)
            }
            fileReader.readAsDataURL(file)
        })
    }
    const handleUpload = async (e) => {
        const file = e.target.files[0]
        const imgUrl = await convertToBase64(file)
        finalInfo.push({imgUrl:imgUrl})
    }
    return(
        <input name='img' type='file' onChange={handleUpload}/>
    )
}

let finalInfo=[]

function RegSteps() {

    const [steps, setSteps] = useState(0)

    function getFieldsFirstStep(e) {
        e.preventDefault()
        let firstname = e.target.elements.firstname.value;
        let lastname = e.target.elements.lastname.value
        let mail = e.target.elements.mail.value
        const res = {
            firstname: firstname,
            lastname: lastname,
            mail: mail
        }
            finalInfo.push(res)
        step++
        setSteps(step)
    }

    function getFieldsSecondStep(e) {
        e.preventDefault()
        let country = e.target.elements.country.value;
        let city = e.target.elements.city.value
        let street = e.target.elements.street.value
        let home = e.target.elements.home.value
        const res ={
            country: country,
            city: city,
            street: street,
            home: home
        }
        finalInfo.push(res)
        step++
        setSteps(step)
    }

    function thirdAndFourthStep(e) {
        e.preventDefault()
        step++
        setSteps(step)
    }


    function stepDec(e) {
        e.preventDefault()
        --step
        setSteps(step)
    }

    if (steps === 0) {
        return (
            <form className='regForm' onSubmit={getFieldsFirstStep}>
                <div className='inputsBlock'>
                    <Input
                        name='firstname'
                        placeholder='Enter first name...'
                        type="text"/>
                    <Input
                        name='lastname'
                        placeholder='Enter last name...'
                        type="text"/>
                    <Input
                        name='mail'
                        placeholder='Enter mail...'
                        type="text"/>
                </div>
                <div className='buttonsBlock'>
                    <div/>
                    <Button text='Next'/>
                </div>
            </form>
        )
    }
    if (steps === 1) {
        return (
            <div className='step2'>
                <form onSubmit={getFieldsSecondStep}>
                    <Input name='country' placeholder='Enter country...'/>
                    <Input name='city' placeholder='Enter city...'/>
                    <Input name='street' placeholder='Enter street...'/>
                    <Input name='home' placeholder='Enter home number...'/>
                    <div className='buttonsBlock'>
                        <Button text='Previous' onClick={stepDec}/>
                        <Button text='Next'/>
                    </div>
                </form>
            </div>
        )
    }
    if (steps === 2) {
        return (
            <div className='step3'>
                <form className='step3form' onSubmit={thirdAndFourthStep}>
                    <p>Chose photo</p>
                    <FileUploader/>
                    <div className='buttonsBlock'>
                        <Button text='Previous' onClick={stepDec}/>
                        <Button text='Next'/>
                    </div>
                </form>
            </div>
        )
    }
    if (steps === 3) {
        return (
            <div className='step4'>
                <form onSubmit={thirdAndFourthStep}>
                    <p>Enter password</p>
                    <Input name='password' type="password"/>
                    <p>Submit password</p>
                    <Input nmae='submittedPassword' type="password"/>
                    <div className='buttonsBlock'>
                        <Button text='Previous' onClick={stepDec}/>
                        <Button text='Send'/>
                    </div>
                </form>
            </div>
        )
    }
    if (steps > 3) {
        return (
            <div className="finalInform">
                <div>
                    <div className='userInfo'>First name: {finalInfo[0].firstname}</div>
                    <div className='userInfo'>Last name: {finalInfo[0].lastname}</div>
                    <div className='userInfo'>Mail: {finalInfo[0].mail}</div>
                    <div className='userInfo'>Country: {finalInfo[1].country}</div>
                    <div className='userInfo'>City: {finalInfo[1].city}</div>
                    <div className='userInfo'>Street: {finalInfo[1].street}</div>
                    <div className='userInfo'>House number: {finalInfo[1].home}</div>
                    <div className='userPhoto'><p>Photo: </p>
                        <img className='userAvatar' src={finalInfo[2].imgUrl} alt={'avatar'}/>
                    </div>
                </div>
            </div>
        )
    }
}

export default RegSteps