import './App.css';
import {userData} from "./condidateArr";
import React from "react";
import {useState} from 'react';

let def = [...userData]

let Card = (props) => {
    return (
        <div className='mainContent'>
            <div className='card'>
                <p className='CardText'>{props.name}</p>
                <p className='CardText'>{props.age}</p>
                <p className='CardText'>{props.gender}</p>
                <p className='CardText'>{props.balance}</p>
                <img className='YouImg' src='https://i1.sndcdn.com/artworks-000580655825-uvkn3k-t500x500.jpg'
                     alt='Ваше фото'/>
            </div>
        </div>
    )
}

function App() {
    const [find, setFind] = useState('')
    def = userData.filter(user => {
        return user.name.toLowerCase().includes(find.toLowerCase())
    })
    const [sort, setSort] = useState('default')

    let sortByAges = () => {
        return def =  userData.sort((a, b) => {
            if (sort === "big") {
                return a.age < b.age ? -1 : 1
            }else{
                return a.age > b.age ? -1 : 1
            }
        })
    }

    let clear = () => {
        setFind('')
        setSort('default')
    }
    return (
        <>
            <header>
                <div className='searchBar'>
                    <input id='findUser' placeholder={'Enter user name...'}
                           onChange={event => setFind(event.target.value)}/>
                </div>
                <div className="sortBar"><select name="selection" id="selectionBar" onChange={e => {
                    sortByAges()
                    setSort(e.target.value)
                }}>
                    <option value="default">...</option>
                    <option value="big">От стариков до молдых</option>
                    <option value="small">От молодых к старикров</option>
                </select>
                    <button className='clear' onClick={clear}>Clear all</button>
                </div>
            </header>
            <div className='mainContent'>
                {def.map(item => <Card {...item}/>)}
            </div>
        </>
    )
}

export default App;
